
//F_CPU=8M
//MCU=STC10F04XE
//P0.0-P0.6 Total positive LED pin
//Trig  = P1^0
//Echo  = P3^2
#include <reg52.h>     
#define uchar unsigned char 
#define uint  unsigned int
#define ulong unsigned long
//***********************************************
sfr  CLK_DIV = 0x97; 
sfr   P0M1   = 0X93;
sfr   P0M0   = 0X94;
sfr   P1M1   = 0X91;
sfr   P1M0   = 0X92;
sfr	P2M1   = 0X95;
sfr	P2M0   = 0X96;
//***********************************************
sbit Trig  = P1^0; // trigger pin
sbit Echo  = P3^2; // echo	  pin 
sbit test  = P1^1; // test    pin 

uchar code SEG7[10]={0xC0,0xF9,0xA4,0xB0,0x99,0x92,0x82,0xF8,0x80,0x90};//LED 0-9
uint distance[4];  
uchar ge,shi,bai,temp,flag,outcomeH,outcomeL,i;  
bit succeed_flag;  

void conversion(uint temp_data);
void delay_20us();
//void pai_xu();

void main(void)   
{  uint distance_data,a,b;
   uchar CONT_1;   
   CLK_DIV=0X03; //clkI/O/8 (From prescaler)
     P0M1 = 0;   
     P1M1 = 0;
     P2M1 = 0;
     P0M0 = 0XFF;
     P1M0 = 0XFF;
     P2M0 = 0XFF;
   i=0;
   flag=0;
	test =0;
	Trig=0;       
	TMOD=0x11;    //timer0time116bit mode
	TR0=1;	      //timer0
    IT0=0;        //set High->Low, External interrupt 0
	ET0=1;        //enable timer0 external interrupt
	EX0=0;        //disable external interrupt
	EA=1;         //enable the total interruption	
  
	
while(1)         
	{
  EA=0;
	     Trig=1;
        delay_20us();
        Trig=0;				//trigger 20us 
        while(Echo==0);		//wait for echo
	     succeed_flag=0;	//clear flag
	     EX0=1;				//enable ext_interrupt
	 	  TH1=0;			//clear timer1
        TL1=0;				//clear timer1
	     TF1=0;				//
        TR1=1;				//start timer1
		EA=1;

      while(TH1 < 30);		//cycle period 65.535ms   
		  TR1=0;			//stop timer1
        EX0=0;				//stop ext_interrupt

    if(succeed_flag==1)
	     { 	
		   distance_data=outcomeH;					//High bit
           distance_data<<=8;						//Low bit
		     distance_data=distance_data|outcomeL;	
            distance_data*=12;						// prescaler 12
           distance_data/=58;						
         }											//why 58cm ?   Y =X*344(m/s)/2
													// X s= 2*Y(m)/344 ==X(s)=0.0058*Y(m) ==(cm)=(us)/58 
    if(succeed_flag==0)
		   {
            distance_data=0;						//no respone
		   	test = !test;							//test led
           }
	   a=distance_data;
       if(b==a) CONT_1=0;
       if(b!=a) CONT_1++;
       if(CONT_1>=3)
		   { CONT_1=0;
			  b=a;
			  conversion(b);
			}          
	 }
}
//***************************************************************
//echo receive
INTO_()  interrupt 0   
 {    
     outcomeH =TH1;    
     outcomeL =TL1;    
     succeed_flag=1;   
     EX0=0;            
  }
//****************************************************************
//timer for display
timer0() interrupt 1  
   {
 	 TH0=0xfd; //INIT timer
	 TL0=0x77;	 	
	 switch(flag)   
      {case 0x00:P0=ge; P2=0xfd;flag++;break;
	    case 0x01:P0=shi;P2=0xfe;flag++;break;
	    case 0x02:P0=bai;P2=0xfb;flag=0;break;
      }
   }
//*****************************************************************
void conversion(uint temp_data)  
 {  
    uchar ge_data,shi_data,bai_data ;
    bai_data=temp_data/100 ;
    temp_data=temp_data%100;   
    shi_data=temp_data/10 ;
    temp_data=temp_data%10;   
    ge_data=temp_data;

    bai_data=SEG7[bai_data];
    shi_data=SEG7[shi_data];
    ge_data =SEG7[ge_data];

    EA=0;
    bai = bai_data;
    shi = shi_data;
    ge  = ge_data ; 
	EA=1;
 }
//******************************************************************
void delay_20us()
 {  uchar bt ;
    for(bt=0;bt<100;bt++);
 }
